<template>
  <div class="measurement-wrapper" :style="{'height':height+10+'px'}">

    <div class="container" :style="{'height':height+'px'}">
      <h3 v-if="isReadingShowSubjectInfo" style="color: #ddd;padding: 5px 0px;margin: 0;">
        <span v-if="subjectCode">{{ subjectCode }} </span>
        <span style="margin-left:5px;">{{ taskBlindName }}</span>
      </h3>
      <!-- 非测量问题 -->
      <div class="lesions">
        <Questions
          ref="ecrf"
          :question-form-change-state="questionFormChangeState"
          :question-form-change-num="questionFormChangeNum"
          :is-first-change-task="isFirstChangeTask"
        />
      </div>
      <!-- 测量问题 -->
      <template v-if="questions.length > 0">
        <div v-for="(qs,index) in questions" :key="index" v-loading="loading" class="lesions lesions_wrapper">
          <h4 v-if="qs.Type === 'group'" style="color: #ddd;padding: 5px 0px;margin: 0;">
            {{ language==='en'?qs.GroupEnName:qs.GroupName }}
          </h4>
          <div class="lesion_list">
            <div v-for="item in qs.Childrens" v-show="!(isBaseLineTask && item.LesionType === 2) && !(isBaseLineTask && item.LesionType === 3)" :key="item.Id">
              <div v-if="item.Type === 'table'" class="flex-row" style="margin:3px 0;">
                <div class="title">{{ item.QuestionName }}</div>
                <div v-if="readingTaskState<2 && (isBaseLineTask || item.LesionType === 2)" class="add-icon" @click.prevent="handleAdd(item)">
                  <i class="el-icon-plus" />
                </div>
              </div>
              <el-collapse
                v-if="item.Type === 'table' && item.TableQuestions"
                v-model="activeName"
                accordion
                @change="handleCollapseChange"
              >
                <el-collapse-item
                  v-for="(q,i) in item.TableQuestions.Answers"
                  :key="`${item.Id}_${q.RowIndex}`"
                  :name="`${item.Id}_${q.RowIndex}`"
                  @contextmenu.prevent.native="collapseRightClick($event,q,item.Id,q.RowIndex)"
                >
                  <template slot="title">
                    <div style="width:300px;position: relative;" :style="{color:(activeName===item.Id+q.RowIndex?'#ffeb3b':'#fff')}">
                      {{ getLesionName(item.OrderMark,q.RowIndex, qs.Childrens) }}
                      <!-- 未保存 -->
                      <el-tooltip v-if="readingTaskState<2 && parseInt(item.TableQuestions.Answers[i].saveTypeEnum) === 0" class="item" effect="dark" :content="$t('trials:reading:button:unsaved')" placement="bottom">
                        <i class="el-icon-warning" style="color:red" />
                      </el-tooltip>
                      <!-- 已更新，未保存 -->
                      <el-tooltip v-if="readingTaskState<2 && parseInt(item.TableQuestions.Answers[i].saveTypeEnum) ===1" class="item" effect="dark" :content="$t('trials:reading:button:incompleteInfor')" placement="bottom">
                        <i class="el-icon-warning" style="color:#ff9800" />
                      </el-tooltip>
                      <div style="position: absolute;left: 60px;top: 2px;">
                        <div style="display: flex;flex-direction: row;font-size: 10px;width:200px;height: 30px;">
                          <div v-if="item.TableQuestions.Answers[i].lesionPart" style="margin-left:10px;">
                            {{ item.TableQuestions.Answers[i].lesionPart }}
                          </div>
                          <div v-if="item.TableQuestions.Answers[i].lesionState" style="margin-left:10px;">
                            {{ $fd('EvaluationOfState',parseInt(item.TableQuestions.Answers[i].lesionState)) }}
                          </div>
                          <div v-if="item.TableQuestions.Answers[i].lesionType" style="margin-left:10px;margin-bottom:5px;">
                            {{ item.TableQuestions.Answers[i].lesionType }}
                          </div>
                          <div v-if="!isNaN(parseInt(item.TableQuestions.Answers[i].lesionNum)) && item.LesionType === 4" style="margin-left:10px;">
                            {{ item.TableQuestions.Answers[i].lesionNum }}
                          </div>
                        </div>
                      </div>
                    </div>
                  </template>
                  <QuestionForm
                    :ref="`${item.Id}_${q.RowIndex}`"
                    :questions="item.TableQuestions.Questions"
                    :answers="item.TableQuestions.Answers[i]"
                    :lesion-type="item.LesionType"
                    :order-mark="item.OrderMark"
                    :table-questions="tableQuestions"
                    :row-index="String(q.RowIndex)"
                    :question-name="item.QuestionName"
                    :parent-qs-id="item.Id"
                    :visit-task-id="visitTaskId"
                    :is-current-task="isCurrentTask"
                    :reading-task-state="readingTaskState"
                    :is-base-line-task="isBaseLineTask"
                    @getReadingQuestionAndAnswer="getReadingQuestionAndAnswer"
                    @determineExistsUnsavedLession="determineExistsUnsavedLession"
                    @resetQuestions="resetQuestions"
                    @close="close"
                  />
                </el-collapse-item>

              </el-collapse>
            </div>
          </div>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import DicomEvent from './../DicomEvent'
import Questions from './../Questions'
import QuestionForm from './QuestionForm'
import store from '@/store'
import { mapGetters } from 'vuex'
export default {
  name: 'PCWG3Questions',
  components: {
    Questions,
    QuestionForm
  },
  props: {
    isShow: {
      type: Boolean,
      required: true
    },
    isReadingShowSubjectInfo: {
      type: Boolean,
      required: true
    },
    questionFormChangeState: {
      type: Boolean,
      default() {
        return false
      }
    },
    questionFormChangeNum: {
      type: Number,
      default() {
        return 0
      }
    }
  },
  data() {
    return {
      height: window.innerHeight - 140,
      questions: [],
      activeName: '',
      activeItem: {
        activeRowIndex: null,
        activeCollapseId: null
      },
      visitTaskId: '',
      isCurrentTask: false,
      loading: false,
      unSaveTargets: [],
      temporaryLesions: [],
      readingTaskState: 2,
      isBaseLineTask: false,
      taskBlindName: '',
      tableQuestions: [],
      isFirstRender: false,
      criterionType: null,
      subjectCode: '',
      isConvertedTask: null,
      isFirstChangeTask: null,
      TaskNum: null,
      BlindName: null,
      isTLMax: false
    }
  },
  computed: {
    ...mapGetters(['visitTaskList', 'language', 'lastCanvasTaskId', 'currentReadingTaskState'])
  },
  watch: {
    lastCanvasTaskId: {
      immediate: true,
      handler(val) {
        if (val) {
          this.initList()
        }
      }
    },
    currentReadingTaskState: {
      immediate: true,
      handler(val) {
        if (val) {
          this.readingTaskState = val
        }
      }
    }
  },
  mounted() {
    this.subjectCode = this.$router.currentRoute.query.subjectCode
    window.addEventListener('message', this.receiveMsg)
    this.criterionType = parseInt(localStorage.getItem('CriterionType'))
    DicomEvent.$on('setCollapseActive', measureData => {
      this.setCollapseActive(measureData)
      console.log('setCollapseActive')
    })
    DicomEvent.$on('changeLesionType', (questionsObj) => {
      this.changeLesionType(questionsObj)
      console.log('changeLesionType')
    })
    DicomEvent.$on('getAllUnSaveLesions', (callback) => {
      var list = this.getAllUnSaveLesions()
      callback(list)
      console.log('getAllUnSaveLesions')
    })

    window.addEventListener('resize', this.setHeight)
  },
  beforeDestroy() {
    DicomEvent.$off('setCollapseActive')
    DicomEvent.$off('changeLesionType')
    DicomEvent.$off('getUnSaveTarget')
  },
  methods: {
    async initList() {
      var i = this.visitTaskList.findIndex(i => i.VisitTaskId === this.lastCanvasTaskId)
      if (i > -1) {
        this.visitTaskId = this.visitTaskList[i].VisitTaskId
        this.taskBlindName = this.visitTaskList[i].TaskBlindName
        this.readingTaskState = this.visitTaskList[i].ReadingTaskState
        this.isBaseLineTask = this.visitTaskList[i].IsBaseLineTask
        this.isCurrentTask = this.visitTaskList[i].IsCurrentTask
        this.activeName = ''
        this.activeItem.activeRowIndex = null
        this.activeItem.activeCollapseId = null
        this.TaskNum = this.visitTaskList[i].VisitTaskNum
        this.BlindName = this.visitTaskList[i].TaskBlindName
        if (!this.visitTaskList[i].IsInit) {
          var loading = this.$loading({ fullscreen: true })
          var triald = this.trialId = this.$router.currentRoute.query.trialId
          if (!this.visitTaskList[i].measureDataInit) {
            await store.dispatch('reading/getMeasuredData', this.visitTaskList[i].VisitTaskId)
          }
          if (!this.visitTaskList[i].studyListInit) {
            await store.dispatch('reading/getStudyInfo', { trialId: triald, subjectVisitId: this.visitTaskList[i].VisitId, visitTaskId: this.visitTaskList[i].VisitTaskId, taskBlindName: this.visitTaskList[i].TaskBlindName })
          }
          if (!this.visitTaskList[i].readingQuestionsInit) {
            await store.dispatch('reading/getReadingQuestionAndAnswer', { trialId: triald, visitTaskId: this.visitTaskList[i].VisitTaskId })
          }
          if (!this.visitTaskList[i].questionsInit) {
            await store.dispatch('reading/getDicomReadingQuestionAnswer', { trialId: triald, visitTaskId: this.visitTaskList[i].VisitTaskId })
          }

          await store.dispatch('reading/setStatus', { visitTaskId: this.visitTaskList[i].VisitTaskId })
          loading.close()
        }
        this.questions = this.visitTaskList[i].ReadingQuestions
        this.$nextTick(() => {
          this.$refs['ecrf'].getQuestions(this.visitTaskId)
          this.getTableQuestions()
          this.tableQuestions.forEach(item => {
            item.TableQuestions.Answers.forEach(i => {
              var refName = `${item.Id}_${i.RowIndex}`
              this.$refs[refName] && this.$refs[refName][0].initForm()
            })
          })
        })
      }
    },
    modifyMeasuredData(measureObj) {
      if (measureObj.questionInfo) {
        this.activeItem.activeCollapseId = measureObj.questionInfo.QuestionId
        this.activeItem.activeRowIndex = String(measureObj.questionInfo.RowIndex)
        this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        this.$refs[refName][0].setMeasureData(measureObj.measureData)
      }
    },
    setMeasuredData(measureData) {
      if (this.activeItem.activeCollapseId) {
        // 判断是否存在测量数据
        this.$nextTick(() => {
          const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
          if (!this.$refs[refName][0].questionForm.MeasureData || (this.$refs[refName][0].questionForm && this.$refs[refName][0].questionForm.MeasureData && measureData.data.uuid === this.$refs[refName][0].questionForm.MeasureData.data.uuid)) {
            this.$refs[refName][0].setMeasureData(measureData)
          } else {
            if (this.isBaseLineTask) {
              this.createNTTarget(measureData)
            } else {
              this.createNLTarget(measureData)
            }
          }
        })
      } else {
        if (this.isBaseLineTask) {
          this.createNTTarget(measureData)
        } else {
          this.createNLTarget(measureData)
        }
      }
    },
    createNTTarget(measureData) {
      var idx = this.tableQuestions.findIndex(item => item.LesionType === 4)
      if (idx > -1) {
        this.addTarget(this.tableQuestions[idx], measureData)
      }
    },
    setCollapseActive(measureData) {
      if (measureData) {
        if (this.activeItem.activeRowIndex === measureData.RowIndex && this.activeItem.activeCollapseId === measureData.QuestionId) {
          return
        } else {
          this.activeItem.activeCollapseId = measureData.QuestionId
          this.activeItem.activeRowIndex = measureData.RowIndex
          this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        }
      }
    },
    // 创建新病灶
    createNLTarget(measureData) {
      var idx = this.tableQuestions.findIndex(item => item.LesionType === 2)
      var idx2 = this.tableQuestions.findIndex(item => item.LesionType === 3)
      if (idx > -1) {
        this.addTarget(this.tableQuestions[idx], measureData, this.tableQuestions[idx2])
      }
    },
    async addTarget(target, measureData, atarget) {
      var obj = { saveTypeEnum: 0 }
      var questions2 = target.TableQuestions.Questions.find(item => item.QuestionMark === 9)
      var questions3 = target.TableQuestions.Questions.find(item => item.QuestionMark === 7)
      questions3 && (obj[questions3.Id] = 2)
      var maxIndex = this.getMaxRowIndex(target.TableQuestions.Answers)
      if (maxIndex < 1 && !this.isBaseLineTask) {
        maxIndex = this.getMaxRowIndex(atarget.TableQuestions.Answers)
      }
      obj.RowIndex = `${maxIndex + 1}.00`
      if (questions2) {
        obj[questions2.Id] = this.BlindName
        obj['BlindName'] = this.BlindName
        obj['TaskNum'] = this.TaskNum
      }
      await store.dispatch('reading/addReadingQuestionAndAnswer', { lesionType: target.LesionType, visitTaskId: this.visitTaskId, lesionObj: obj })

      this.activeItem.activeRowIndex = String(obj.RowIndex)
      this.activeItem.activeCollapseId = target.Id
      this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      this.$nextTick(() => {
        this.$refs[refName][0].setMeasureData(measureData)
      })
    },
    determineExistsUnsavedLession(callback) {
      this.getUnSaveTarget()
      if (this.unSaveTargets.length > 0) {
        var rowIndex = String(this.unSaveTargets[0].rowIndex)
        var questionId = this.unSaveTargets[0].questionId
        if (rowIndex === String(this.activeItem.activeRowIndex) && questionId === this.activeItem.activeCollapseId) {
          callback(true)
          return
        } else {
          let msg = this.$t('trials:reading:warnning:msg17')
          msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
          this.$confirm(msg, {
            type: 'warning',
            showCancelButton: false,
            callback: action => { }
          })
          callback(false)
          return
        }
      }
      callback(true)
      // loading.close()
      return
    },
    getReadingQuestionAndAnswer() {
      return new Promise(async resolve => {
        const loading = this.$loading({ fullscreen: true })
        await store.dispatch('reading/refreshReadingQuestionAndAnswer', { trialId: this.$router.currentRoute.query.trialId, visitTaskId: this.visitTaskId }).then(() => {
          var idx = this.visitTaskList.findIndex(i => i.VisitTaskId === this.visitTaskId)
          if (idx > -1) {
            if (this.visitTaskList[idx].ReadingQuestions.length > 0) {
              this.questions = this.visitTaskList[idx].ReadingQuestions
            }
            this.readingTaskState = this.visitTaskList[idx].ReadingTaskState
            this.isBaseLineTask = this.visitTaskList[idx].IsBaseLineTask
            this.isCurrentTask = this.visitTaskList[idx].IsCurrentTask
          }
          this.getTableQuestions()
          this.$nextTick(() => {
            this.tableQuestions.forEach(item => {
              item.TableQuestions.Answers.forEach(i => {
                var refName = `${item.Id}_${i.RowIndex}`
                this.$refs[refName] && this.$refs[refName][0].initForm()
              })
            })
          })
        })
        await store.dispatch('reading/refreshMeasuredData', this.visitTaskId)
        DicomEvent.$emit('getMeasureData')
        loading.close()
        resolve()
      })
    },
    getUnSaveTarget() {
      this.unSaveTargets = []
      this.isTLMax = false
      this.tableQuestions.map(item => {
        if (item.TableQuestions && item.TableQuestions.Answers && item.TableQuestions.Answers.length > 0) {
          item.TableQuestions.Answers.map(t => {
            if (!t.RowId) {
              var lessionName = this.getLesionName(item.OrderMark, t.RowIndex)
              this.unSaveTargets.push({ lessionName: lessionName, rowIndex: t.RowIndex, questionId: item.Id })
            }
          })
          if (item.LesionType === 2 && item.MaxQuestionCount > 0 && item.TableQuestions.Answers.length >= item.MaxQuestionCount) {
            this.isTLMax = true
          }
        }
      })
      return this.unSaveTargets
    },
    async resetQuestions(obj) {
      this.setQuestions(this.questions, obj)
      await store.dispatch('reading/setReadingQuestionAndAnswer', { questions: this.questions, visitTaskId: this.visitTaskId })
      this.getTableQuestions()
    },
    setQuestions(questions, obj) {
      questions.forEach(item => {
        if (item.Type === 'table' && item.Id === obj.questionId) {
          var idx = item.TableQuestions.Answers.findIndex(i => i.RowIndex === obj.rowIndex)
          item.TableQuestions.Answers[idx].loctation = obj.lesionOrgan
          item.TableQuestions.Answers[idx].lesionPart = obj.lesionPart
          item.TableQuestions.Answers[idx].lesionState = obj.lesionState
          item.TableQuestions.Answers[idx].lesionType = obj.lesionType
          item.TableQuestions.Answers[idx].lesionNum = obj.lesionNum
          item.TableQuestions.Answers[idx].saveTypeEnum = obj.saveTypeEnum
          for (const i in obj.anwsers) {
            if (i === 'MeasureData' && obj.anwsers[i]) {
              item.TableQuestions.Answers[idx].InstanceId = obj.anwsers[i].instanceId
              item.TableQuestions.Answers[idx].SeriesId = obj.anwsers[i].seriesId
              item.TableQuestions.Answers[idx][i] = JSON.stringify(obj.anwsers[i])
              item.TableQuestions.Answers[idx].isDicomReading = !(obj.anwsers[i].IsDicomReading === false || obj.anwsers[i].IsDicomReading === 'False')
            } else {
              item.TableQuestions.Answers[idx][i] = String(obj.anwsers[i])
            }
          }
        }
        if (item.Childrens.length > 0) {
          this.setQuestions(item.Childrens, obj)
        }
      })
    },
    getQuestions(questions) {
      questions.forEach(item => {
        if (item.Type === 'table' && item.TableQuestions && item.TableQuestions.Answers.length > 0) {
          item.TableQuestions.Answers.forEach(answerObj => {
            this.$set(answerObj, 'loctation', this.getQuestionAnswer(item.TableQuestions.Questions, 6, answerObj))
            var lesionNum = this.getQuestionAnswer(item.TableQuestions.Questions, 11, answerObj)
            lesionNum = !isNaN(parseInt(lesionNum)) ? parseInt(lesionNum) : ''
            this.$set(answerObj, 'lesionNum', lesionNum)
            var lesionState = this.getQuestionAnswer(item.TableQuestions.Questions, 7, answerObj)

            lesionState = !isNaN(parseInt(lesionState)) ? parseInt(lesionState) : ''
            this.$set(answerObj, 'lesionState', lesionState)
            if (answerObj.RowId) {
              var idx = this.questions.findIndex(i => i.QuestionMark === 11)
              if (idx > -1) {
                this.$set(answerObj, 'saveTypeEnum', isNaN(parseInt(lesionNum)) ? 1 : 2)
              } else {
                this.$set(answerObj, 'saveTypeEnum', isNaN(parseInt(lesionState)) ? 1 : 2)
              }
            } else {
              this.$set(answerObj, 'saveTypeEnum', 0)
            }
          })
        }
        if (item.Childrens.length > 0) {
          this.getQuestions(item.Childrens)
        }
      })
      return questions
    },
    getTableQuestions() {
      this.tableQuestions = []
      this.questions.map(item => {
        if (item.Type === 'table') {
          this.tableQuestions.push(item)
        }
        if (item.Childrens.length > 0) {
          this.getTableQuestionsChild(item.Childrens)
        }
      })
    },
    getTableQuestionsChild(obj) {
      obj.map(item => {
        if (item.Type === 'table') {
          this.tableQuestions.push(item)
        }
        if (item.Childrens.length > 0) {
          this.getTableQuestionsChild(item.Childrens)
        }
      })
    },
    getLesionName(orderMark, rowIndex, qs) {
      var lessionName = ''
      var rowIndexArr = rowIndex.split('.')
      var x = parseInt(rowIndexArr[0])
      var y = parseInt(rowIndexArr[1])
      if (y > 0) {
        y = String.fromCharCode(parseInt(rowIndexArr[1]) - 1 + 65 + 32)
        lessionName = `${orderMark}${String(x).padStart(2, '0')}${y}`
      } else {
        lessionName = `${orderMark}${String(x).padStart(2, '0')}`
      }
      return lessionName
    },
    handleAdd(qs) {
      this.getUnSaveTarget()
      if (this.unSaveTargets.length > 0) {
        let msg = this.$t('trials:reading:warnning:msg5')
        msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
        this.$confirm(msg, {
          type: 'warning',
          showCancelButton: false,
          callback: action => {}
        })
        return
      }
      if (!!qs.MaxQuestionCount && qs.MaxQuestionCount <= qs.TableQuestions.Answers.length) {
        // `${qs.QuestionName}个数最多不能超过${qs.MaxQuestionCount}个`
        let msg = this.$t('trials:reading:pcwg:msg3').replace('xxx', qs.QuestionName)
        msg = msg.replace('yyy', qs.MaxQuestionCount)
        this.$confirm(msg, {
          type: 'warning',
          showCancelButton: false,
          callback: action => {}
        })
      } else {
        var obj = { saveTypeEnum: 0 }
        var idx2 = this.tableQuestions.findIndex(item => item.LesionType === 3)
        var maxIndex = this.getMaxRowIndex(qs.TableQuestions.Answers)
        if (maxIndex < 1) {
          maxIndex = this.getMaxRowIndex(this.tableQuestions[idx2].TableQuestions.Answers)
        }
        obj.RowIndex = `${maxIndex + 1}.00`
        qs.TableQuestions.Questions.forEach(item => {
          if (item.QuestionMark === 9) {
            obj[item.Id] = this.BlindName
            obj['BlindName'] = this.BlindName
            obj['TaskNum'] = this.TaskNum
          } else if (item.QuestionMark === 7) {
            obj[item.Id] = 2
          } else {
            obj[item.Id] = ''
          }
        })
        qs.TableQuestions.Answers.push(obj)
        this.activeItem.activeRowIndex = String(obj.RowIndex)
        this.activeItem.activeCollapseId = qs.Id
        this.activeName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      }
    },
    getMaxRowIndex(answerList) {
      if (answerList.length > 0) {
        var arr = []
        answerList.forEach(item => {
          var rowIndex = item.RowIndex
          arr.push(parseInt(rowIndex))
        })
        var max = Math.max.apply(null, arr)
        return max
      } else {
        return 0
      }
    },
    handleCollapseChange(val) {
      if (this.activeName) {
        var arr = this.activeName.split('_')
        this.activeItem.activeRowIndex = arr[1]
        this.activeItem.activeCollapseId = arr[0]
        this.$nextTick(() => {
          const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
          if (this.$refs[refName][0].questionForm.IsDicomReading !== false) {
            var markTool = this.$refs[refName][0].currentMarkTool
            var readingTaskState = this.readingTaskState
            var isMarked = !!this.$refs[refName][0].questionForm.MeasureData
            DicomEvent.$emit('imageLocation', { questionId: this.activeItem.activeCollapseId, rowIndex: this.activeItem.activeRowIndex, visitTaskId: this.visitTaskId, lesionName: this.$refs[refName][0].lesionMark, lesionType: this.$refs[refName][0].lesionType, markTool, readingTaskState, isMarked })
          }
        })
      } else {
        this.activeItem.activeRowIndex = null
        this.activeItem.activeCollapseId = null
      }
    },
    collapseRightClick(e, obj, activeCollapseId, activeRowIndex) {
      if (obj.IsDicomReading !== false) {
        const refName = `${activeCollapseId}_${activeRowIndex}`
        DicomEvent.$emit('imageLocation', { questionId: activeCollapseId, rowIndex: activeRowIndex, visitTaskId: this.visitTaskId, lesionName: this.$refs[refName][0].lesionMark, lesionType: this.$refs[refName][0].lesionType })
      }
      e.stopImmediatePropagation()
      e.stopPropagation()
      e.preventDefault()
    },
    getAllUnSaveLesions() {
      var arr = []
      this.tableQuestions.map(item => {
        if (item.TableQuestions && item.TableQuestions.Answers) {
          item.TableQuestions.Answers.map(t => {
            const refName = `${item.Id}_${t.RowIndex}`
            if (this.$refs[refName] && this.$refs[refName][0] && this.$refs[refName][0].questionForm.saveTypeEnum !== 2) {
              var lessionName = this.getLesionName(item.OrderMark, t.RowIndex)
              arr.push({ lessionName: lessionName, rowIndex: t.RowIndex, questionId: item.Id })
            }
          })
        }
      })
      return arr
    },

    isCanActiveTool(toolName) {
      this.getUnSaveTarget()
      if (!this.activeName) {
        if (this.isTLMax) {
          // `新病灶已到达最大数，无法添加`
          return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg1') }
        }
      } else {
        const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        if (this.$refs[refName][0].questionForm.MeasureData && this.isTLMax) {
          // `新病灶已到达最大数，无法添加`
          return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg1') }
        }
      }
      if (this.unSaveTargets.length > 0) {
        var rowIndex = String(this.unSaveTargets[0].rowIndex)
        var questionId = this.unSaveTargets[0].questionId
        const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
        if (rowIndex === this.activeItem.activeRowIndex && questionId === this.activeItem.activeCollapseId && !this.$refs[refName][0].questionForm.MeasureData) {
          return this.checkToolCanActive(toolName)
        } else {
          let msg = this.$t('trials:reading:warnning:msg5')
          msg = msg.replace('xxx', this.unSaveTargets[0].lessionName)
          return { isCanActiveTool: false, reason: msg }
        }
      } else {
        if (this.activeItem.activeCollapseId) {
          return this.checkToolCanActive(toolName)
        } else {
          if (this.isBaseLineTask) {
            if (toolName === 'ArrowAnnotate' || toolName === 'RectangleRoi') {
              return { isCanActiveTool: true, reason: '' }
            } else {
              return { isCanActiveTool: false, reason: '' }
            }
          } else {
            if (toolName === 'ArrowAnnotate') {
              return { isCanActiveTool: true, reason: '' }
            } else {
              return { isCanActiveTool: false, reason: '' }
            }
          }
        }
      }
    },
    checkToolCanActive(toolName) {
      const refName = `${this.activeItem.activeCollapseId}_${this.activeItem.activeRowIndex}`
      if (!this.$refs[refName][0].questionForm.MeasureData) {
        if (this.isBaseLineTask) {
          if (toolName !== 'RectangleRoi' && toolName !== 'ArrowAnnotate') {
            // '基线病灶需使用矩形工具或箭头工具'
            return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg4') }
          } else {
            return { isCanActiveTool: true, reason: '' }
          }
        } else {
          if (this.$refs[refName][0].lesionType === 4 && toolName !== 'RectangleRoi' && toolName !== 'ArrowAnnotate') {
            // '基线病灶需使用矩形工具或箭头工具'
            return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg4') }
          } else if (this.$refs[refName][0].lesionType !== 4 && toolName !== 'ArrowAnnotate') {
            // 请使用箭头工具
            return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg5') }
          } else {
            return { isCanActiveTool: true, reason: '' }
          }
        }
      } else {
        if (toolName !== 'ArrowAnnotate') {
          // 请使用箭头工具
          return { isCanActiveTool: false, reason: this.$t('trials:reading:pcwg:msg5') }
        } else {
          return { isCanActiveTool: true, reason: '' }
        }
      }
    },
    async close(questionsObj) {
      if (questionsObj) {
        this.getReadingQuestionAndAnswer(questionsObj.visitTaskId)
      }
      this.activeItem.activeRowIndex = null
      this.activeItem.activeCollapseId = null
      this.activeName = ''
    }
  }
}
</script>

<style lang="scss" scoped>
.measurement-wrapper{
  overflow-y: auto;
  // overflow: hidden;

  .container{
    padding: 10px;
  }
  .title{
    padding: 5px;
    font-weight: bold;
    color: #ddd;
    font-size: 15px;

  }
  .add-icon{
    padding: 5px;
    font-weight: bold;
    color: #ddd;
    font-size: 15px;
    border: 1px solid #938b8b;
    margin-bottom: 2px;
    cursor: pointer;
  }
  .add-icon:hover{
    background-color: #607d8b;
  }

  .flex-row{
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    background-color: #424242;

  }
  .lesion_list{
    position: relative;
  }
  .el-collapse{
    border-bottom:none;
    border-top:none;
    /deep/ .el-collapse-item{
      background-color: #000!important;
      color: #ddd;

    }
    /deep/ .el-collapse-item__header{
      background-color: #000!important;
      color: #ddd;
      border-bottom-color:#5a5a5a;
      padding-left: 5px;
      height: 35px;
      line-height: 35px;
    }
    /deep/ .el-collapse-item__wrap{
      background-color: #000!important;
      color: #ddd;
    }
    /deep/ .el-collapse-item__content{
      width:260px;
      position: absolute;
      top: 0px;
      right: 0px;
      // border: 1px solid #ffeb3b;
      border: 1px solid #fff;
      z-index: 1;
      color: #ddd;
      padding: 5px;
      background-color:#1e1e1e;
    }

  }
}
</style>

